// pages/attestation/index.js
const request = require('../../utils/request.js');
const util = require('../../utils/util.js')

const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    nvabarData: {
      showCapsule: 0, //是否显示左上角图标，消息中心   1表示显示    0表示不显示
      showBack: 1, //返回
      title: '我的企业', //导航栏 中间的标题
      // 此页面 页面内容距最顶部的距离
      height: app.globalData.height * 2 + 20,
    },
    company: {},
    flag: false,
    // 需求
    yjrzxqList: [],
    xqtext: '请选择',
    xqindex: null,
    show: false,
    endInfo: {},
    imgBase: '',
    imgBase1: '', //身份证
    buttonShow: false,
    idButtonShow: false,
  },
  // 开户行
  yjrzxqListChange: function (e) {
    // console.log('yjrzxqListChange发送选择改变，携带值为', e)
    this.setData({
      xqindex: e.detail.value,
      xqtext: '',
    })
  },
  // 开户行
  whenData: function () {
    wx.request({
      method: "get",
      url: app.globalData.publicUrl + 'api/financial/institution',
      data: {},
      success: (e) => {
        if (e.data.errcode == 0) {
          this.setData({
            yjrzxqList: e.data.data,
          })
        } else {
          wx.showToast({
            title: e.data.details ? e.data.details : e.data.errmsg,
            icon: 'none',
            duration: 1500
          })
        }
      }
    })
  },

  goHome: function (e) {
    wx.redirectTo({
      url: '/pages/home/index'
    })
  },
  // 认证信息提交
  formSubmit: function (e) {
    // console.log('form发生了submit事件，携带数据为：', e.detail.value)
    let user = wx.getStorageSync('user')
    const companyName = e.detail.value.company_name;
    const opening_bank = e.detail.value.opening_bank;
    const reg_num = e.detail.value.reg_num;
    var that = this;
    if (user) {
      e.detail.value.uid = user._id;
      e.detail.value.business_license = this.data.imgBase;
      e.detail.value.status = '1';
      let form = e.detail.value;
      let json = {};
      json.companyName = companyName;
      json.uscCode = reg_num;
      if (opening_bank) {
        wx.showLoading({
          title: '加载中',
          mask: true
        })
        wx.request({
          method: "POST",
          url: app.globalData.publicUrl + 'api/financial/companyidentify',
          data: form,
          success: (e) => {
            wx.hideLoading();
            // console.log('认证结果=============',e.data)
            if (e.data.errcode == 0 && e.data.errmsg == 'ok') {
              if (e.data.data == "已认证") {
                wx.showModal({
                  title: '提示',
                  content: '该企业已经被认证,请校验企业信息是否正确',
                })
              } else{
                user.roles = '1';
                user.company_name = companyName;
                user.opening_bank = opening_bank;
                wx.setStorage({
                  key: 'user',
                  data: user,
                })
                wx.showModal({
                  title: '',
                  content: '认证信息添加成功！',
                  showCancel: false,
                  confirmText: '返回首页',
                  success: function (res) {
                    if (res.confirm) {
                      wx.redirectTo({
                        url: '/pages/home/index'
                      })
                    }
                  }
                })
              }
              
              // else {
              //   console.log('开始请求接口时间================>'+util.formatTime(new Date()))
              //   let illtime = util.formatTime2(new Date());//认证时间
              //   wx.request({
              //     method: "POST",
              //     url: app.globalData.publicUrl + 'api/financial/companyuser/update/' + user._id,
              //     data: {
              //       roles: '1',
              //       company_name: companyName,
              //       opening_bank: opening_bank,
              //       illtime:illtime,
              //     },
              //     success: (e) => {
              //       console.log('接口返回数据时间================>'+util.formatTime(new Date()))
              //       wx.hideLoading();
              //       delete e.data.data.IDcard;
              //       wx.setStorage({
              //         key: 'user',
              //         data: e.data.data,
              //       })
              //       // that.setData({
              //       //   show :true
              //       // })
              //     }
              //   })
              //   // 认证后信息不可以修改，置灰
              //   this.setData({
              //     flag: true
              //   })
              //   wx.showModal({
              //     title: '',
              //     content: '认证信息添加成功！',
              //     showCancel: false,
              //     confirmText: '返回首页',
              //     success: function (res) {
              //       if (res.confirm) {
              //         wx.redirectTo({
              //           url: '/pages/home/index'
              //         })
              //       }
              //     }
              //   })
              // }
            } else {
              wx.hideLoading();
              wx.showToast({
                title: e.data.details ? e.data.details : e.data.errmsg,
                icon: 'none',
                duration: 1500
              })
            }
          }
        })
      } else {
        wx.showModal({
          title: '提示',
          content: '请选择开户行',
          success(res) {
            if (res.confirm) {
              // console.log('用户点击确定')
            } else if (res.cancel) {
              // console.log('用户点击取消')
            }
          }
        })
      }
    } else {
      wx.showModal({
        title: '提示',
        content: '登录信息失效，请重新登录!!!',
        showCancel: false,
        confirmText: '返回登录',
        success: function (res) {
          if (res.confirm) {
            wx.redirectTo({
              url: '/pages/login/index'
            })
          }
        }
      })
    }
  },

  // 实名认证
  realName: function (idcardno, name, img) {
    request.query({
      url: 'api/financial/phoneMessage/getIdcheck',
      data: {
        cardNo: idcardno,
        realName: name
      },
      method: 'get'
    }).then((res) => {
      // console.log('实名结果',res)

      if (res.data.errmsg == 'ok') {
        if (res.data.errcode == 0) {
          // console.log('实名结果',res.data)
          if (res.data.result.isok) {
            this.updateUser(img, name);
          } else {
            wx.hideLoading();
            wx.showModal({
              title: '提示',
              content: '身份证实名认证失败，请上传正确的身份证件照片',
            })
          }
        }
      } else {
        wx.hideLoading();
        wx.showModal({
          title: '提示',
          content: res.data.errmsg,
        })
      }

    }).catch((error) => {
      console.log(error)
    });
  },

  // 身份证拍照获取图片路径
  chooseimage1() {
    wx.showLoading({
      title: '加载中',
    })
    var _this = this;
    wx.chooseImage({
      count: 1, // 默认9
      sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
      sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
      success: function (res) {
        // console.log('拍照获取图片路径',res);
        // 读取本地文件内容
        wx.showLoading({
          title: '加载中',
        })
        wx.getFileSystemManager().readFile({
          filePath: res.tempFilePaths[0],
          encoding: 'base64',
          success: res => {
            //返回临时文件路径
            // console.log('读取本地文件basema ',res.data)
            let img = 'data:image/png;base64,' + res.data
            const bodys = {
              "base64Str": img
            };
            const AppCode = '4638ef02c8e248e1b12d55b1170e4feb';

            // console.log('读取本地文件basema ',res.data)
            // console.log(JSON.stringify( {base64Str:res.data}))
            wx.request({
              url: 'https://zid.market.alicloudapi.com/thirdnode/ImageAI/idcardfrontrecongnition',
              method: 'POST',
              header: {
                Authorization: 'APPCODE ' + AppCode,
                'content-type': 'application/x-www-form-urlencoded'
              },
              data: {
                base64Str: img
              },
              dataType: 'json',
              success: (e) => {
                // console.log('身份证ocr识别返回数据',e.data)
                if (e.data.error_code == 0) {
                  if (e.data.result) {
                    const idcardno = e.data.result.idcardno
                    const name = e.data.result.name
                    _this.realName(idcardno, name, img)
                  }
                } else {
                  wx.hideLoading();
                  _this.setData({
                    show: false,
                    buttonShow: false,
                    idButtonShow: true
                  });
                  wx.showModal({
                    title: '提示',
                    content: '身份证OCR识别失败',
                  })
                }
              },
            })

  



            // request.query({
            //   url: 'api/financial/phoneMessage/getCardMessage',
            //   data: {
            //     idCardImg: img
            //   },
            //   method: 'post'
            // }).then((res) => {
            //   console.log('身份证ocr识别返回数据',res.data)
            //   if(res.data.errcode == 0){
            //     if(res.data.result){
            //       const idcardno = res.data.result.idcardno
            //       const name = res.data.result.name
            //       _this.realName(idcardno,name,img)
            //     } else {
            //       wx.hideLoading();
            //       wx.showModal({
            //         title: '提示',
            //         content: res.data.errmsg,
            //       })
            //     }
            //   }else{
            //     wx.hideLoading();
            //     _this.setData({
            //       show: false,
            //       buttonShow: false,
            //       idButtonShow:true
            //     });
            //     wx.showModal({
            //       title: '提示',
            //       content: '身份证OCR识别失败',
            //     })
            //   }
            //   wx.hideLoading();
            // }).catch((error) => {
            //   console.log(error)
            //   wx.hideLoading();

            //   wx.showModal({
            //     title: '提示',
            //     content: '请求超时，请稍后重试',
            //   })
            // });



          },
          // 错误信息
          fail: console.error
        })
      },
      fail: function () {
        wx.hideLoading();
      }

    })

  },
  // 拍照获取图片路径
  chooseimage() {
    wx.showLoading({
      title: '加载中',
    })
    var _this = this;
    wx.chooseImage({
      count: 1, // 默认9
      sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
      sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
      success: function (res) {
        // console.log('拍照获取图片路径===================>',res);
        // 读取本地文件内容
        wx.showLoading({
          title: '加载中',
        })
        wx.getFileSystemManager().readFile({
          filePath: res.tempFilePaths[0],
          encoding: 'base64',
          success: res => {
            //返回临时文件路径
            // console.log('读取本地文件basema ',res.data)
            _this.setData({
              imgBase: res.data,
              show: true,
              buttonShow: false,
            })
            const bodys = {
              image: res.data
            };
             const AppCode = '4638ef02c8e248e1b12d55b1170e4feb';
            //const AppCode = 'c4b0d2a5228941329938f641f31c943d'
            wx.request({
              url: 'https://dm-58.data.aliyun.com/rest/160601/ocr/ocr_business_license.json',
              method: 'POST',
              header: {
                Authorization: 'APPCODE ' + AppCode
              },
              // contentType: 'application/json; charset=UTF-8',
              data: JSON.stringify(bodys),
              dataType: 'json',
              success: (e) => {
                // console.log('success=============', e);
                e.data.company_name = e.data.name
                _this.setData({
                  company: e.data,
                  //show: true,
                })
                wx.hideLoading();
                // console.log('OCR结果 ', res)
              },
            })
            // request.query({
            //   url: 'api/financial/phoneMessage/getMessage',
            //   data: {
            //     img: res.data
            //   },
            //   method: 'post'
            // }).then((res) => {
            //   res.data.company_name = res.data.name
            //   _this.setData({
            //     company: res.data
            //   })
            //   wx.hideLoading();
            //   // console.log('OCR结果 ', res)
            //   // console.log('OCR结果 ', _this.data.company)
            // }).catch((error) => {
            //   wx.hideLoading();
            //   console.log(error)
            //   wx.showModal({
            //     title: '提示',
            //     content: '请求超时，请稍后重试',
            //   })
            // });
          },
          // 错误信息
          fail: console.error
        })
      },
      fail: function (err) {
        wx.hideLoading();
      }
    })
  },

  // update company_user
  updateUser: function (img, name) {
    let user = wx.getStorageSync('user')
    // console.log('实名前',user)
    request.query({
      url: 'api/financial/companyuser/update/' + user.id,
      data: {
        authentication: '1',
        person: name,
        IDcard: img
      },
      method: 'post'
    }).then((res) => {
      // console.log("update====实名",res.data);
      wx.hideLoading();
      if (res.data.errcode == 0) {
        delete res.data.data.IDcard;
        wx.setStorage({
          key: 'user',
          data: res.data.data,
        })
        this.setData({
          idButtonShow: false,
          buttonShow: true
        })
        wx.showModal({
          title: '提示',
          content: '身份证实名成功,请进行企业认证',
        })
      } else {
        wx.showModal({
          title: '提示',
          content: '身份证实名失败',
        })
      }
      // console.log('实名后',wx.getStorageSync('user'))
    }).catch((error) => {
      console.log(error)
    });
  },



  //数据回显
  loadData: function () {
    wx.showLoading({
      title: '加载中',
    })
    let user = wx.getStorageSync('user')
    // console.log('user', user)
    // console.log('开始请求接口时间================>'+util.formatTime(new Date()))
    wx.request({
      method: "get",
      url: app.globalData.publicUrl + 'api/financial/companyidentify',
      data: {
        uid: user._id
      },
      success: (e) => {
        // console.log('结束请求接口时间================>'+util.formatTime(new Date()))
        // console.log('company============================>', e.data.data[0]);
        delete e.data.data[0].business_license
        wx.hideLoading();
        if (e.data.data.length) {
          this.setData({
            company: e.data.data[0],
            flag: true,
            show: true,
          })
          const open_id = e.data.data[0].opening_bank
          wx.request({
            method: "get",
            url: app.globalData.publicUrl + 'api/financial/institution/' + open_id,
            data: {},
            success: (e) => {
              // console.log('bank', e.data.data.name);
              this.setData({
                xqtext: e.data.data.name,
              })
            }
          })
          // this.setData({
          //   company: e.data.data[0],
          //   flag: true,
          //   show: true,
          // })
        }
        // else {
        //   wx.showToast({
        //     title: e.data.details?e.data.details:e.data.errmsg,
        //     icon: 'none',
        //     duration: 1500
        // })
        // }
      }
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let user = wx.getStorageSync('user')
    // console.log("onload"+user);
    if (user) {
      this.whenData();
      if (user.authentication == '1') {
        if (user.roles == '1') {
          this.setData({
            buttonShow: false,
          })
          this.loadData();
        } else {
          this.setData({
            buttonShow: true,
          })
        }
      } else {
        this.setData({
          idButtonShow: true,
          buttonShow: false
        })
      }
    } else {
      wx.showModal({
        title: '提示',
        content: '登录信息失效，请重新登录!!!',
        showCancel: false,
        confirmText: '返回登录',
        success: function (res) {
          if (res.confirm) {
            wx.redirectTo({
              url: '/pages/login/index'
            })
          }
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})